Level = Core.class()

function Level:init()
	self.map = TiledMap.new("maps/map01")
	self.hero = Hero.new()

	self.hero:setX(200)
	self.hero:setY(290)
	
	local font = Font.new("fonts/DroidSerif-Bold.txt", "fonts/DroidSerif-Bold.png")
	self.text = TextField.new(font, "Tap to start!")
	
	self.text:setX(260)
	self.text:setY(240)
	
	stage:addChild(self.map)
	stage:addChild(self.hero)
	stage:addChild(self.text)

	self.frame = 0
	self.started = false
	
	stage:addEventListener(Event.ENTER_FRAME, self.onEnterFrame, self)
	stage:addEventListener(Event.MOUSE_UP, self.onMouseUp, self)
	world:addEventListener(Event.PRE_SOLVE, self.onBeginContact, self)
	world:addEventListener(Event.END_CONTACT, self.onEndContact, self)	
end

function Level:onMouseUp()
	if not self.started then
		self.started = true		
		self.hero.moving = true	
		stage:removeChild(self.text)
	end
end

function Level:onEnterFrame()
	if self.started then	
		if self.hero.moving then
			self.map:move(-3, 0)
			self.frame = 0
		end
		
		self.frame = self.frame + 1
		world:step(1.5/60, 8, 3)	
	end
end

function Level:onBeginContact(event)
	local bodyA = event.fixtureA:getBody()
	local bodyB = event.fixtureB:getBody()
	local ground = self.map:getObjectsByType("ground")
	
	if (bodyA == self.hero.body or bodyB == self.hero.body) and
		(table_find(ground,bodyA,bodyB)) then
		
		self.hero.onGround = true
		self.hero.jumping = false
	else
		self.hero.moving = false		
	end		
end

function Level:onEndContact(event)
	local bodyA = event.fixtureA:getBody()
	local bodyB = event.fixtureB:getBody()
	local ground = self.map:getObjectsByType("ground")
	
	print("onEndContact")
	
	if (bodyA == self.hero.body or bodyB == self.hero.body) and
		(table_find(ground,bodyA,bodyB)) then
		
		print("1")
		
		self.hero.onGround = false
	else
	
		print("2")
	
		self.hero.moving = true
	end
end

function table_find(groundtype,bodyA,bodyB)
	for i = 1, #groundtype do
		local value = groundtype[i]
		if (value.body == bodyA) or (value.body == bodyB) then
		  return true
		end
	  end
    return false
end